<?php

namespace Teknisa\ACL\Repositories;

use Doctrine\DBAL\Connection;
use Doctrine\DBAL\DBALException;
use Teknisa\ACL\Util\InstanceProvider;


class GrupoOperador {

    public function findOpergrupop($filter, $cdoperador, $bindParams, $typeBindParams): array
    {
        $query ="
         SELECT * FROM (SELECT O.NRORG, O.CDOPERADOR, O.CDGRUPOPER, G.DSGRUPOPER, O.IDMENUPRINOP, O.DTINCLUSAO, O.DTULTATU, O.CDOPERINCLUSAO, O.CDOPERULTATU,
        OPERIN.NMOPERADOR AS NMOPERINCLUSAO,OPERUP.NMOPERADOR AS NMOPERULTATU
        FROM OPERGRUPOP O
        JOIN GRUPOPER G ON O.CDGRUPOPER = G.CDGRUPOPER
        LEFT JOIN OPERADOR OPERIN ON O.CDOPERINCLUSAO = OPERIN.CDOPERADOR AND O.NRORG = OPERIN.NRORG
        LEFT JOIN OPERADOR OPERUP ON O.CDOPERULTATU = OPERUP.CDOPERADOR AND O.NRORG = OPERUP.NRORG
        WHERE O.CDOPERADOR = :CDOPERADOR)
        WHERE 1 = 1
             $filter";

        $bindParams['CDOPERADOR'] = $cdoperador;
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $bindParams, $typeBindParams);

    }

    /**
     * @param $cdoperador
     * @param $nrperfilacesso
     * @return mixed[]
     */
    public function findGrupooperByGrupopcont($cdoperador, $nrperfilacesso): array
    {
        $query ="
                SELECT G.CDGRUPOPER, GR.DSGRUPOPER, G.NRPERFILACESSO, G.NRORG
                  FROM GRUPOPCONT   G
                  JOIN GRUPOPER GR ON G.CDGRUPOPER = GR.CDGRUPOPER
                                  AND G.NRORG = GR.NRORG
                 WHERE G.CDGRUPOPER NOT IN (SELECT CDGRUPOPER 
                                              FROM OPERGRUPOP
                                             WHERE CDOPERADOR =:CDOPERADOR)
                   AND G.NRPERFILACESSO = :NRPERFILACESSO
                ORDER BY G.CDGRUPOPER, GR.DSGRUPOPER, G.NRPERFILACESSO, G.NRORG" ;
        $params = array(
            "CDOPERADOR" => $cdoperador,
            'NRPERFILACESSO' => $nrperfilacesso
        );
        $std = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function findGrupooperNotInOperGrupOp($cdoperador)
    {
        $query ="
               SELECT G.CDGRUPOPER, G.DSGRUPOPER, G.NRORG
                  FROM GRUPOPER   G
                 WHERE G.CDGRUPOPER NOT IN (SELECT CDGRUPOPER 
                                              FROM OPERGRUPOP
                                             WHERE CDOPERADOR =:CDOPERADOR)
                   AND G.IDATIVO = 'S'
                ORDER BY G.CDGRUPOPER, G.DSGRUPOPER, G.NRORG" ;

        $params = array(
            "CDOPERADOR" => $cdoperador,
        );
        $std = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function updateOpergrupop($idmenuprinop, $cdgrupoper, $cdoperador)
    {
        $query = "
               UPDATE OPERGRUPOP
                  SET IDMENUPRINOP = :IDMENUPRINOP,
                  DTULTATU         = SYSDATE,
                  CDOPERULTATU     = :CDOPERULTATU
                WHERE CDGRUPOPER = :CDGRUPOPER 
                  AND CDOPERADOR = :CDOPERADOR";

        $params = array(
            "IDMENUPRINOP" => $idmenuprinop,
            "CDGRUPOPER" => $cdgrupoper,
            "CDOPERADOR" => $cdoperador,
            "CDOPERULTATU" => InstanceProvider::getLibEnvironment()->getCurrentUserId(),
        );

        try {
            $std = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }


}
